#ifndef DEBUG_H
#define DEBUG_H

/*
 * $Id: debug.h,v 1.1 2013/01/14 21:47:39 jacadcaps Exp $
 */

void dprintf(char *, ...);

#ifdef DEBUG

#ifdef __GNUC__ /* GCC */
#define __FUNC__ __FUNCTION__
#endif

#ifdef AMIGAOS
extern void kprintf(char *, ...);
#endif

#ifdef __MORPHOS__
//void dprintf(char *, ... );
#define kprintf dprintf
#endif

/*
 * Straight debug
 *
 * Example: DB(("you suck %ld times\n", num));
 */
#define DB(x)   { kprintf(__FILE__ "[%4ld]/" __FUNC__ "() : ",__LINE__); kprintf x ; }


/*
 * Straight debug with 1 second delay
 *
 * Example: DBD(("you suck %ld times and slowly\n", num));
 */
#define DBD(x)  { Delay(50); kprintf(__FILE__ "[%4ld]:" __FUNC__ "() : ",__LINE__); kprintf x ; }


#else

#define DB(x)
#define DBL(lvl,x)
#define DBD(x)

#endif /* !DEBUG */

#endif /* DEBUG_H */
